diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/test/wifi-phy-reception-test.cc ns-3.39/src/wifi/test/wifi-phy-reception-test.cc
--- ns-3.38/src/wifi/test/wifi-phy-reception-test.cc	2023-03-16 20:54:23.876869400 -0700
+++ ns-3.39/src/wifi/test/wifi-phy-reception-test.cc	2023-07-05 14:23:48.133428300 -0700
@@ -37,14 +37,17 @@
 #include "ns3/pointer.h"
 #include "ns3/rng-seed-manager.h"
 #include "ns3/simple-frame-capture-model.h"
+#include "ns3/single-model-spectrum-channel.h"
 #include "ns3/spectrum-wifi-helper.h"
 #include "ns3/spectrum-wifi-phy.h"
 #include "ns3/test.h"
 #include "ns3/threshold-preamble-detection-model.h"
+#include "ns3/wifi-bandwidth-filter.h"
 #include "ns3/wifi-mac-header.h"
 #include "ns3/wifi-mpdu.h"
 #include "ns3/wifi-net-device.h"
 #include "ns3/wifi-psdu.h"
+#include "ns3/wifi-spectrum-phy-interface.h"
 #include "ns3/wifi-spectrum-signal-parameters.h"
 #include "ns3/wifi-spectrum-value-helper.h"
 #include "ns3/wifi-utils.h"
@@ -65,44 +68,33 @@
  * \ingroup wifi-test
  * \ingroup tests
  *
- * \brief Preamble detection test w/o frame capture
+ * \brief Wifi Phy Reception Test base class
  */
-class TestThresholdPreambleDetectionWithoutFrameCapture : public TestCase
+class WifiPhyReceptionTest : public TestCase
 {
   public:
-    TestThresholdPreambleDetectionWithoutFrameCapture();
-    ~TestThresholdPreambleDetectionWithoutFrameCapture() override;
+    /**
+     * Constructor
+     *
+     * \param test_name the test name
+     */
+    WifiPhyReceptionTest(std::string test_name);
+    /**
+     * Destructor
+     */
+    ~WifiPhyReceptionTest() override = default;
 
   protected:
     void DoSetup() override;
     void DoTeardown() override;
-    Ptr<SpectrumWifiPhy> m_phy; ///< Phy
+
     /**
      * Send packet function
      * \param rxPowerDbm the transmit power in dBm
+     * \param packetSize the size of the packet in bytes
+     * \param mcs the MCS to transmit the packet
      */
-    void SendPacket(double rxPowerDbm);
-    /**
-     * Spectrum wifi receive success function
-     * \param psdu the PSDU
-     * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
-     * \param txVector the transmit vector
-     * \param statusPerMpdu reception status per MPDU
-     */
-    void RxSuccess(Ptr<const WifiPsdu> psdu,
-                   RxSignalInfo rxSignalInfo,
-                   WifiTxVector txVector,
-                   std::vector<bool> statusPerMpdu);
-    /**
-     * Spectrum wifi receive failure function
-     * \param psdu the PSDU
-     */
-    void RxFailure(Ptr<const WifiPsdu> psdu);
-    uint32_t m_countRxSuccess; ///< count RX success
-    uint32_t m_countRxFailure; ///< count RX failure
-
-  private:
-    void DoRun() override;
+    void SendPacket(double rxPowerDbm, uint32_t packetSize, uint8_t mcs);
 
     /**
      * Schedule now to check  the PHY state
@@ -114,32 +106,23 @@
      * \param expectedState the expected PHY state
      */
     void DoCheckPhyState(WifiPhyState expectedState);
-    /**
-     * Check the number of received packets
-     * \param expectedSuccessCount the number of successfully received packets
-     * \param expectedFailureCount the number of unsuccessfuly received packets
-     */
-    void CheckRxPacketCount(uint32_t expectedSuccessCount, uint32_t expectedFailureCount);
 
-    uint64_t m_uid; //!< the UID to use for the PPDU
+    Ptr<SpectrumWifiPhy> m_phy; //!< the PHY
+    uint64_t m_uid{0};          //!< the UID to use for the PPDU
 };
 
-TestThresholdPreambleDetectionWithoutFrameCapture::
-    TestThresholdPreambleDetectionWithoutFrameCapture()
-    : TestCase("Threshold preamble detection model test when no frame capture model is applied"),
-      m_countRxSuccess(0),
-      m_countRxFailure(0),
-      m_uid(0)
+WifiPhyReceptionTest::WifiPhyReceptionTest(std::string test_name)
+    : TestCase{test_name}
 {
 }
 
 void
-TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket(double rxPowerDbm)
+WifiPhyReceptionTest::SendPacket(double rxPowerDbm, uint32_t packetSize, uint8_t mcs)
 {
     WifiTxVector txVector =
-        WifiTxVector(HePhy::GetHeMcs7(), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, 20, false);
+        WifiTxVector(HePhy::GetHeMcs(mcs), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, 20, false);
 
-    Ptr<Packet> pkt = Create<Packet>(1000);
+    Ptr<Packet> pkt = Create<Packet>(packetSize);
     WifiMacHeader hdr;
 
     hdr.SetType(WIFI_MAC_QOSDATA);
@@ -149,7 +132,7 @@
     Time txDuration = m_phy->CalculateTxDuration(psdu->GetSize(), txVector, m_phy->GetPhyBand());
 
     Ptr<WifiPpdu> ppdu =
-        Create<HePpdu>(psdu, txVector, FREQUENCY, txDuration, WIFI_PHY_BAND_5GHZ, m_uid++);
+        Create<HePpdu>(psdu, txVector, m_phy->GetOperatingChannel(), txDuration, m_uid++);
 
     Ptr<SpectrumValue> txPowerSpectrum =
         WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity(FREQUENCY,
@@ -164,21 +147,19 @@
     txParams->ppdu = ppdu;
     txParams->txWidth = CHANNEL_WIDTH;
 
-    m_phy->StartRx(txParams);
+    m_phy->StartRx(txParams, nullptr);
 }
 
 void
-TestThresholdPreambleDetectionWithoutFrameCapture::CheckPhyState(WifiPhyState expectedState)
+WifiPhyReceptionTest::CheckPhyState(WifiPhyState expectedState)
 {
     // This is needed to make sure PHY state will be checked as the last event if a state change
     // occurred at the exact same time as the check
-    Simulator::ScheduleNow(&TestThresholdPreambleDetectionWithoutFrameCapture::DoCheckPhyState,
-                           this,
-                           expectedState);
+    Simulator::ScheduleNow(&WifiPhyReceptionTest::DoCheckPhyState, this, expectedState);
 }
 
 void
-TestThresholdPreambleDetectionWithoutFrameCapture::DoCheckPhyState(WifiPhyState expectedState)
+WifiPhyReceptionTest::DoCheckPhyState(WifiPhyState expectedState)
 {
     WifiPhyState currentState;
     PointerValue ptr;
@@ -193,6 +174,83 @@
 }
 
 void
+WifiPhyReceptionTest::DoSetup()
+{
+    Ptr<MultiModelSpectrumChannel> spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
+    Ptr<Node> node = CreateObject<Node>();
+    Ptr<WifiNetDevice> dev = CreateObject<WifiNetDevice>();
+    m_phy = CreateObject<SpectrumWifiPhy>();
+    Ptr<InterferenceHelper> interferenceHelper = CreateObject<InterferenceHelper>();
+    m_phy->SetInterferenceHelper(interferenceHelper);
+    Ptr<ErrorRateModel> error = CreateObject<NistErrorRateModel>();
+    m_phy->SetErrorRateModel(error);
+    m_phy->SetDevice(dev);
+    m_phy->AddChannel(spectrumChannel);
+    m_phy->SetOperatingChannel(WifiPhy::ChannelTuple{CHANNEL_NUMBER, 0, WIFI_PHY_BAND_5GHZ, 0});
+    m_phy->ConfigureStandard(WIFI_STANDARD_80211ax);
+    dev->SetPhy(m_phy);
+    node->AddDevice(dev);
+}
+
+void
+WifiPhyReceptionTest::DoTeardown()
+{
+    m_phy->Dispose();
+    m_phy = nullptr;
+}
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief Preamble detection test w/o frame capture
+ */
+class TestThresholdPreambleDetectionWithoutFrameCapture : public WifiPhyReceptionTest
+{
+  public:
+    TestThresholdPreambleDetectionWithoutFrameCapture();
+
+  protected:
+    void DoSetup() override;
+
+    /**
+     * Spectrum wifi receive success function
+     * \param psdu the PSDU
+     * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
+     * \param txVector the transmit vector
+     * \param statusPerMpdu reception status per MPDU
+     */
+    void RxSuccess(Ptr<const WifiPsdu> psdu,
+                   RxSignalInfo rxSignalInfo,
+                   WifiTxVector txVector,
+                   std::vector<bool> statusPerMpdu);
+    /**
+     * Spectrum wifi receive failure function
+     * \param psdu the PSDU
+     */
+    void RxFailure(Ptr<const WifiPsdu> psdu);
+    uint32_t m_countRxSuccess{0}; ///< count RX success
+    uint32_t m_countRxFailure{0}; ///< count RX failure
+
+  private:
+    void DoRun() override;
+
+    /**
+     * Check the number of received packets
+     * \param expectedSuccessCount the number of successfully received packets
+     * \param expectedFailureCount the number of unsuccessfully received packets
+     */
+    void CheckRxPacketCount(uint32_t expectedSuccessCount, uint32_t expectedFailureCount);
+};
+
+TestThresholdPreambleDetectionWithoutFrameCapture::
+    TestThresholdPreambleDetectionWithoutFrameCapture()
+    : WifiPhyReceptionTest(
+          "Threshold preamble detection model test when no frame capture model is applied")
+{
+}
+
+void
 TestThresholdPreambleDetectionWithoutFrameCapture::CheckRxPacketCount(uint32_t expectedSuccessCount,
                                                                       uint32_t expectedFailureCount)
 {
@@ -221,22 +279,11 @@
     m_countRxFailure++;
 }
 
-TestThresholdPreambleDetectionWithoutFrameCapture::
-    ~TestThresholdPreambleDetectionWithoutFrameCapture()
-{
-    m_phy = nullptr;
-}
-
 void
 TestThresholdPreambleDetectionWithoutFrameCapture::DoSetup()
 {
-    m_phy = CreateObject<SpectrumWifiPhy>();
-    m_phy->ConfigureStandard(WIFI_STANDARD_80211ax);
-    Ptr<InterferenceHelper> interferenceHelper = CreateObject<InterferenceHelper>();
-    m_phy->SetInterferenceHelper(interferenceHelper);
-    Ptr<ErrorRateModel> error = CreateObject<NistErrorRateModel>();
-    m_phy->SetErrorRateModel(error);
-    m_phy->SetOperatingChannel(WifiPhy::ChannelTuple{CHANNEL_NUMBER, 0, WIFI_PHY_BAND_5GHZ, 0});
+    WifiPhyReceptionTest::DoSetup();
+
     m_phy->SetReceiveOkCallback(
         MakeCallback(&TestThresholdPreambleDetectionWithoutFrameCapture::RxSuccess, this));
     m_phy->SetReceiveErrorCallback(
@@ -250,13 +297,6 @@
 }
 
 void
-TestThresholdPreambleDetectionWithoutFrameCapture::DoTeardown()
-{
-    m_phy->Dispose();
-    m_phy = nullptr;
-}
-
-void
 TestThresholdPreambleDetectionWithoutFrameCapture::DoRun()
 {
     RngSeedManager::SetSeed(1);
@@ -274,7 +314,9 @@
     Simulator::Schedule(Seconds(1.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     // At 4us, preamble should be successfully detected and STA PHY STATE should move from IDLE to
     // CCA_BUSY
     Simulator::Schedule(Seconds(1.0) + NanoSeconds(3999),
@@ -320,11 +362,15 @@
     Simulator::Schedule(Seconds(2.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(2.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     // At 4us, no preamble is successfully detected and STA PHY STATE should move from IDLE to
     // CCA_BUSY
     Simulator::Schedule(Seconds(2.0) + NanoSeconds(3999),
@@ -362,11 +408,15 @@
     Simulator::Schedule(Seconds(3.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(3.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm - 3);
+                        rxPowerDbm - 3,
+                        1000,
+                        7);
     // At 4us, no preamble is successfully detected, hence STA PHY STATE should move from IDLE to
     // CCA_BUSY
     Simulator::Schedule(Seconds(3.0) + NanoSeconds(3999),
@@ -403,11 +453,15 @@
     Simulator::Schedule(Seconds(4.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(4.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm - 6);
+                        rxPowerDbm - 6,
+                        1000,
+                        7);
     // At 4us, preamble should be successfully detected and STA PHY STATE should move from IDLE to
     // CCA_BUSY
     Simulator::Schedule(Seconds(4.0) + NanoSeconds(3999),
@@ -463,11 +517,15 @@
     Simulator::Schedule(Seconds(5.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(5.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm + 3);
+                        rxPowerDbm + 3,
+                        1000,
+                        7);
     // At 6us (hence 4us after the last signal is received), no preamble is successfully detected,
     // hence STA PHY STATE should move from IDLE to CCA_BUSY
     Simulator::Schedule(Seconds(5.0) + NanoSeconds(5999),
@@ -506,7 +564,9 @@
     Simulator::Schedule(Seconds(6.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     // At 4us, preamble should be successfully detected and STA PHY STATE should move from IDLE to
     // CCA_BUSY
     Simulator::Schedule(Seconds(6.0) + NanoSeconds(3999),
@@ -552,11 +612,15 @@
     Simulator::Schedule(Seconds(7.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(7.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     // At 4us, STA PHY STATE should stay IDLE
     Simulator::Schedule(Seconds(7.0) + MicroSeconds(4.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::CheckPhyState,
@@ -580,11 +644,15 @@
     Simulator::Schedule(Seconds(8.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(8.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm - 3);
+                        rxPowerDbm - 3,
+                        1000,
+                        7);
     // At 4us, STA PHY STATE should stay IDLE
     Simulator::Schedule(Seconds(8.0) + MicroSeconds(4.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::CheckPhyState,
@@ -606,11 +674,15 @@
     Simulator::Schedule(Seconds(9.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(9.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm - 6);
+                        rxPowerDbm - 6,
+                        1000,
+                        7);
     // At 4us, preamble should be successfully detected and STA PHY STATE should move from IDLE to
     // CCA_BUSY
     Simulator::Schedule(Seconds(9.0) + NanoSeconds(3999),
@@ -656,11 +728,15 @@
     Simulator::Schedule(Seconds(10.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(10.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm + 3);
+                        rxPowerDbm + 3,
+                        1000,
+                        7);
     // At 4us, STA PHY STATE should stay IDLE
     Simulator::Schedule(Seconds(10.0) + MicroSeconds(4.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::CheckPhyState,
@@ -683,7 +759,9 @@
     Simulator::Schedule(Seconds(11.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     // At 4us, preamble should be successfully detected and STA PHY STATE should move from IDLE to
     // CCA_BUSY
     Simulator::Schedule(Seconds(11.0) + NanoSeconds(3999),
@@ -724,7 +802,9 @@
     Simulator::Schedule(Seconds(12.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     // At 4us, STA PHY state should be IDLE
     Simulator::Schedule(Seconds(12.0) + MicroSeconds(4.0),
                         &TestThresholdPreambleDetectionWithoutFrameCapture::CheckPhyState,
@@ -741,21 +821,14 @@
  *
  * \brief Preamble detection test w/o frame capture
  */
-class TestThresholdPreambleDetectionWithFrameCapture : public TestCase
+class TestThresholdPreambleDetectionWithFrameCapture : public WifiPhyReceptionTest
 {
   public:
     TestThresholdPreambleDetectionWithFrameCapture();
-    ~TestThresholdPreambleDetectionWithFrameCapture() override;
 
   protected:
     void DoSetup() override;
-    void DoTeardown() override;
-    Ptr<SpectrumWifiPhy> m_phy; ///< Phy
-    /**
-     * Send packet function
-     * \param rxPowerDbm the transmit power in dBm
-     */
-    void SendPacket(double rxPowerDbm);
+
     /**
      * Spectrum wifi receive success function
      * \param psdu the PSDU
@@ -772,100 +845,27 @@
      * \param psdu the PSDU
      */
     void RxFailure(Ptr<const WifiPsdu> psdu);
-    uint32_t m_countRxSuccess; ///< count RX success
-    uint32_t m_countRxFailure; ///< count RX failure
+    uint32_t m_countRxSuccess{0}; ///< count RX success
+    uint32_t m_countRxFailure{0}; ///< count RX failure
 
   private:
     void DoRun() override;
 
     /**
-     * Schedule now to check  the PHY state
-     * \param expectedState the expected PHY state
-     */
-    void CheckPhyState(WifiPhyState expectedState);
-    /**
-     * Check the PHY state now
-     * \param expectedState the expected PHY state
-     */
-    void DoCheckPhyState(WifiPhyState expectedState);
-    /**
      * Check the number of received packets
      * \param expectedSuccessCount the number of successfully received packets
      * \param expectedFailureCount the number of unsuccessfuly received packets
      */
     void CheckRxPacketCount(uint32_t expectedSuccessCount, uint32_t expectedFailureCount);
-
-    uint64_t m_uid; //!< the UID to use for the PPDU
 };
 
 TestThresholdPreambleDetectionWithFrameCapture::TestThresholdPreambleDetectionWithFrameCapture()
-    : TestCase(
-          "Threshold preamble detection model test when simple frame capture model is applied"),
-      m_countRxSuccess(0),
-      m_countRxFailure(0),
-      m_uid(0)
+    : WifiPhyReceptionTest(
+          "Threshold preamble detection model test when simple frame capture model is applied")
 {
 }
 
 void
-TestThresholdPreambleDetectionWithFrameCapture::SendPacket(double rxPowerDbm)
-{
-    WifiTxVector txVector =
-        WifiTxVector(HePhy::GetHeMcs7(), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, 20, false);
-
-    Ptr<Packet> pkt = Create<Packet>(1000);
-    WifiMacHeader hdr;
-
-    hdr.SetType(WIFI_MAC_QOSDATA);
-    hdr.SetQosTid(0);
-
-    Ptr<WifiPsdu> psdu = Create<WifiPsdu>(pkt, hdr);
-    Time txDuration = m_phy->CalculateTxDuration(psdu->GetSize(), txVector, m_phy->GetPhyBand());
-
-    Ptr<WifiPpdu> ppdu =
-        Create<HePpdu>(psdu, txVector, FREQUENCY, txDuration, WIFI_PHY_BAND_5GHZ, m_uid++);
-
-    Ptr<SpectrumValue> txPowerSpectrum =
-        WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity(FREQUENCY,
-                                                                    CHANNEL_WIDTH,
-                                                                    DbmToW(rxPowerDbm),
-                                                                    GUARD_WIDTH);
-
-    Ptr<WifiSpectrumSignalParameters> txParams = Create<WifiSpectrumSignalParameters>();
-    txParams->psd = txPowerSpectrum;
-    txParams->txPhy = nullptr;
-    txParams->duration = txDuration;
-    txParams->ppdu = ppdu;
-
-    m_phy->StartRx(txParams);
-}
-
-void
-TestThresholdPreambleDetectionWithFrameCapture::CheckPhyState(WifiPhyState expectedState)
-{
-    // This is needed to make sure PHY state will be checked as the last event if a state change
-    // occurred at the exact same time as the check
-    Simulator::ScheduleNow(&TestThresholdPreambleDetectionWithFrameCapture::DoCheckPhyState,
-                           this,
-                           expectedState);
-}
-
-void
-TestThresholdPreambleDetectionWithFrameCapture::DoCheckPhyState(WifiPhyState expectedState)
-{
-    WifiPhyState currentState;
-    PointerValue ptr;
-    m_phy->GetAttribute("State", ptr);
-    Ptr<WifiPhyStateHelper> state = DynamicCast<WifiPhyStateHelper>(ptr.Get<WifiPhyStateHelper>());
-    currentState = state->GetState();
-    NS_LOG_FUNCTION(this << currentState);
-    NS_TEST_ASSERT_MSG_EQ(currentState,
-                          expectedState,
-                          "PHY State " << currentState << " does not match expected state "
-                                       << expectedState << " at " << Simulator::Now());
-}
-
-void
 TestThresholdPreambleDetectionWithFrameCapture::CheckRxPacketCount(uint32_t expectedSuccessCount,
                                                                    uint32_t expectedFailureCount)
 {
@@ -894,21 +894,11 @@
     m_countRxFailure++;
 }
 
-TestThresholdPreambleDetectionWithFrameCapture::~TestThresholdPreambleDetectionWithFrameCapture()
-{
-    m_phy = nullptr;
-}
-
 void
 TestThresholdPreambleDetectionWithFrameCapture::DoSetup()
 {
-    m_phy = CreateObject<SpectrumWifiPhy>();
-    m_phy->ConfigureStandard(WIFI_STANDARD_80211ax);
-    Ptr<InterferenceHelper> interferenceHelper = CreateObject<InterferenceHelper>();
-    m_phy->SetInterferenceHelper(interferenceHelper);
-    Ptr<ErrorRateModel> error = CreateObject<NistErrorRateModel>();
-    m_phy->SetErrorRateModel(error);
-    m_phy->SetOperatingChannel(WifiPhy::ChannelTuple{CHANNEL_NUMBER, 0, WIFI_PHY_BAND_5GHZ, 0});
+    WifiPhyReceptionTest::DoSetup();
+
     m_phy->SetReceiveOkCallback(
         MakeCallback(&TestThresholdPreambleDetectionWithFrameCapture::RxSuccess, this));
     m_phy->SetReceiveErrorCallback(
@@ -927,13 +917,6 @@
 }
 
 void
-TestThresholdPreambleDetectionWithFrameCapture::DoTeardown()
-{
-    m_phy->Dispose();
-    m_phy = nullptr;
-}
-
-void
 TestThresholdPreambleDetectionWithFrameCapture::DoRun()
 {
     RngSeedManager::SetSeed(1);
@@ -951,7 +934,9 @@
     Simulator::Schedule(Seconds(1.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     // At 4us, preamble should be successfully detected and STA PHY STATE should move from IDLE to
     // CCA_BUSY
     Simulator::Schedule(Seconds(1.0) + NanoSeconds(3999),
@@ -997,11 +982,15 @@
     Simulator::Schedule(Seconds(2.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(2.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     // At 4us, no preamble is successfully detected, hence STA PHY STATE should move from IDLE to
     // CCA_BUSY
     Simulator::Schedule(Seconds(2.0) + NanoSeconds(3999),
@@ -1039,11 +1028,15 @@
     Simulator::Schedule(Seconds(3.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(3.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm - 3);
+                        rxPowerDbm - 3,
+                        1000,
+                        7);
     // At 4us, no preamble is successfully detected, hence STA PHY STATE should move from IDLE to
     // CCA_BUSY
     Simulator::Schedule(Seconds(3.0) + NanoSeconds(3999),
@@ -1080,11 +1073,15 @@
     Simulator::Schedule(Seconds(4.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(4.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm - 6);
+                        rxPowerDbm - 6,
+                        1000,
+                        7);
     // At 4us, preamble should be successfully detected and STA PHY STATE should move from IDLE to
     // CCA_BUSY
     Simulator::Schedule(Seconds(4.0) + NanoSeconds(3999),
@@ -1140,11 +1137,15 @@
     Simulator::Schedule(Seconds(5.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(5.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm + 3);
+                        rxPowerDbm + 3,
+                        1000,
+                        7);
     // At 4us, STA PHY STATE should stay IDLE
     Simulator::Schedule(Seconds(5.0) + MicroSeconds(4.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::CheckPhyState,
@@ -1186,11 +1187,15 @@
     Simulator::Schedule(Seconds(6.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(6.0) + MicroSeconds(2.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm + 6);
+                        rxPowerDbm + 6,
+                        1000,
+                        7);
     // At 4us, STA PHY STATE should stay IDLE
     Simulator::Schedule(Seconds(6.0) + MicroSeconds(4.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::CheckPhyState,
@@ -1242,11 +1247,15 @@
     Simulator::Schedule(Seconds(7.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(7.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     // At 4us, no preamble is successfully detected, hence STA PHY STATE should move from IDLE to
     // CCA_BUSY
     Simulator::Schedule(Seconds(7.0) + NanoSeconds(3999),
@@ -1284,11 +1293,15 @@
     Simulator::Schedule(Seconds(8.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(8.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm - 3);
+                        rxPowerDbm - 3,
+                        1000,
+                        7);
     // At 4us, no preamble is successfully detected, hence STA PHY STATE should move from IDLE to
     // CCA_BUSY
     Simulator::Schedule(Seconds(8.0) + NanoSeconds(3999),
@@ -1324,11 +1337,15 @@
     Simulator::Schedule(Seconds(9.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm);
+                        rxPowerDbm,
+                        1000,
+                        7);
     Simulator::Schedule(Seconds(9.0),
                         &TestThresholdPreambleDetectionWithFrameCapture::SendPacket,
                         this,
-                        rxPowerDbm - 6);
+                        rxPowerDbm - 6,
+                        1000,
+                        7);
     // At 4us, preamble should be successfully detected and STA PHY STATE should move from IDLE to
     // CCA_BUSY
     Simulator::Schedule(Seconds(9.0) + NanoSeconds(3999),
